From 57e218362352404344549daceaa38057ebb2cb13 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Thu, 2 Feb 2012 15:01:11 -0600
Subject: Quick Edit as a grade report

---
 grade/report/quick_edit/db/access.php              |   40 +++++++++
 grade/report/quick_edit/index.php                  |   85 ++++++++++++++++++++
 .../quick_edit/lang/en/gradereport_quick_edit.php  |   27 ++++++
 grade/report/quick_edit/lib.php                    |   46 +++++++++++
 grade/report/quick_edit/version.php                |   27 ++++++
 5 files changed, 225 insertions(+), 0 deletions(-)
 create mode 100755 grade/report/quick_edit/db/access.php
 create mode 100755 grade/report/quick_edit/index.php
 create mode 100755 grade/report/quick_edit/lang/en/gradereport_quick_edit.php
 create mode 100755 grade/report/quick_edit/lib.php
 create mode 100755 grade/report/quick_edit/version.php

diff --git a/grade/report/quick_edit/db/access.php b/grade/report/quick_edit/db/access.php
new file mode 100755
index 0000000..d8c4b35
--- /dev/null
+++ b/grade/report/quick_edit/db/access.php
@@ -0,0 +1,40 @@
+<?php  // $Id: access.php,v 1.5 2008-05-10 06:34:23 pcali1 Exp $
+
+///////////////////////////////////////////////////////////////////////////
+//                                                                       //
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.com                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards  Martin Dougiamas  http://moodle.com       //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+
+$capabilities = array(
+
+    'gradereport/quick_edit:view' => array(
+        'riskbitmask' => RISK_PERSONAL,
+        'captype' => 'read',
+        'contextlevel' => CONTEXT_COURSE,
+        'archetypes' => array(
+            'editingteacher' => CAP_ALLOW,
+            'manager' => CAP_ALLOW,
+        )
+    )
+);
+
+?>
diff --git a/grade/report/quick_edit/index.php b/grade/report/quick_edit/index.php
new file mode 100755
index 0000000..c943128
--- /dev/null
+++ b/grade/report/quick_edit/index.php
@@ -0,0 +1,85 @@
+<?php
+
+///////////////////////////////////////////////////////////////////////////
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.org                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards  Martin Dougiamas  http://moodle.com       //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+require_once '../../../config.php';
+require_once $CFG->dirroot.'/lib/gradelib.php';
+require_once $CFG->dirroot.'/grade/lib.php';
+require_once $CFG->dirroot.'/grade/report/quick_edit/lib.php';
+
+$courseid = required_param('id', PARAM_INT);
+$itemtype = optional_param('item', 'grade', PARAM_TEXT);
+$itemid = optional_param('itemid', 0, PARAM_INT);
+$groupid  = optional_param('group', null, PARAM_INT);
+
+$PAGE->set_url(new moodle_url('/grade/report/quick_edit/index.php', array(
+    'id' => $courseid,
+    'item' => $itemtype,
+    'itemid' => $itemid,
+    'group' => $groupid
+)));
+
+if (!$course = $DB->get_record('course', array('id' => $courseid))) {
+    print_error('nocourseid');
+}
+
+require_login($course);
+
+$context = get_context_instance(CONTEXT_COURSE, $course->id);
+
+// This is the normal requirements
+require_capability('gradereport/quick_edit:view', $context);
+require_capability('moodle/grade:viewall', $context);
+require_capability('moodle/grade:edit', $context);
+// End permission
+
+$_s = function($key, $a = null) {
+    return get_string($key, 'gradereport_quick_edit');
+};
+
+$gpr = new grade_plugin_return(array(
+    'type' => 'report', 'plugin' => 'quick_edit', 'courseid' => $courseid
+));
+
+if (!isset($USER->grade_last_report)) {
+    $USER->grade_last_report = array();
+}
+$USER->grade_last_report[$course->id] = 'quick_edit';
+
+grade_regrade_final_grades($courseid);
+
+$reportname = $_s('pluginname');
+
+$PAGE->set_context($context);
+
+print_grade_page_head($course->id, 'report', 'quick_edit', $reportname, false);
+
+$report = new grade_report_quick_edit(
+    $courseid, $gpr, $context, $itemtype, $itemid, $group
+);
+
+echo $report->output();
+
+echo $OUTPUT->footer();
+
+?>
diff --git a/grade/report/quick_edit/lang/en/gradereport_quick_edit.php b/grade/report/quick_edit/lang/en/gradereport_quick_edit.php
new file mode 100755
index 0000000..c000b2d
--- /dev/null
+++ b/grade/report/quick_edit/lang/en/gradereport_quick_edit.php
@@ -0,0 +1,27 @@
+<?php
+
+///////////////////////////////////////////////////////////////////////////
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.org                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards  Martin Dougiamas  http://moodle.com       //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+// General Strings
+$string['pluginname'] = 'Quick Edit';
+$string['quick_edit:view'] = 'View the '.$string['pluginname'].' report';
diff --git a/grade/report/quick_edit/lib.php b/grade/report/quick_edit/lib.php
new file mode 100755
index 0000000..8b05270
--- /dev/null
+++ b/grade/report/quick_edit/lib.php
@@ -0,0 +1,46 @@
+<?php
+
+///////////////////////////////////////////////////////////////////////////
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.org                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards  Martin Dougiamas  http://moodle.com       //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+require_once($CFG->dirroot . '/grade/report/lib.php');
+require_once($CFG->libdir.'/tablelib.php');
+
+class grade_report_quick_edit extends grade_report {
+
+    function process_data($data) {
+    }
+
+    function process_action($target, $action) {
+    }
+
+    function _s($key, $a = null) {
+        return get_string($key, 'gradereport_quick_edit', $a);
+    }
+
+    function __construct($courseid, $gpr, $context, $itemtype, $itemid, $groupid=null) {
+        parent::__construct($courseid, $gpr, $context);
+    }
+
+    function output() {
+    }
+}
diff --git a/grade/report/quick_edit/version.php b/grade/report/quick_edit/version.php
new file mode 100755
index 0000000..438ddd1
--- /dev/null
+++ b/grade/report/quick_edit/version.php
@@ -0,0 +1,27 @@
+<?php
+
+///////////////////////////////////////////////////////////////////////////
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.org                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards  Martin Dougiamas  http://moodle.com       //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+$plugin->version  = 2012020214;
+$plugin->requires = 2010090501;
+
-- 
1.7.1


